//MyTexture.cpp
#include <d3d9.h>
#include <d3dx9.h>
#include <stdio.h>

#include "MyTexture.h"

MyTexture::MyTexture( const char* szTextureName)
{
	size_t len = strlen(szTextureName);
	m_szTextureName = new char [len + 1]; 
	strcpy_s( m_szTextureName, len + 1, szTextureName);

	m_pDeviceTexture = 0;
	m_filterMode.magFiler = D3DTEXF_LINEAR;
	m_filterMode.minFilter = D3DTEXF_LINEAR;
	m_filterMode.mipFiler = D3DTEXF_LINEAR;
}
//------------------------------------------------------------------------------------------
MyTexture::~MyTexture()
{
	Release();
}
//------------------------------------------------------------------------------------------
void MyTexture::Release()
{
	if( m_szTextureName)
		delete [] m_szTextureName;
	if( m_pDeviceTexture)
		m_pDeviceTexture->Release();

	m_szTextureName = 0;
	m_pDeviceTexture = NULL;
}
//------------------------------------------------------------------------------------------
bool MyTexture::SetTexture( IDirect3DDevice9* pDevice)
{
	pDevice->SetSamplerState( 0, D3DSAMP_MAGFILTER, m_filterMode.magFiler);
	pDevice->SetSamplerState( 0, D3DSAMP_MINFILTER, m_filterMode.minFilter);
	pDevice->SetSamplerState( 0, D3DSAMP_MIPFILTER, m_filterMode.mipFiler);

	if(m_szTextureName && m_pDeviceTexture == 0)
	{
		if(Load( pDevice) == false)
		{
			delete [] m_szTextureName;
			m_szTextureName = 0;
		}
	}
	pDevice->SetTexture(0, m_pDeviceTexture);
	return true;
}
//------------------------------------------------------------------------------------------
bool MyTexture::Load( IDirect3DDevice9* pDevice)
{
	if(FAILED(D3DXCreateTextureFromFile(pDevice, m_szTextureName, &m_pDeviceTexture)))
		return false;
	else
		return true;
}
//------------------------------------------------------------------------------------------
void MyTexture::SetFilterMode( int iIndex, FilterMode filterMode)
{
	m_filterMode = filterMode;
}
//------------------------------------------------------------------------------------------
MyTexture::FilterMode MyTexture::GetFilerMode( int iIndex)
{
	return m_filterMode;
}